import 'package:fish_redux/fish_redux.dart';

enum InteractiveEnrollmentAction {
  clickNext,
  clickGoBack,
  settingParameters,
  changeIdentity,
  onChangeIdentity,
  changeAppInfoState,
  onChangeAppInfoState,
  editAppInfo,
  onEditAppInfo,
  changeUserId,
  onChangeUserId,
  changeRoomId,
  onChangeRoomId,
}

class InteractiveEnrollmentActionCreator {

  static Action clickNext() =>
      const Action(InteractiveEnrollmentAction.clickNext);

  static Action clickGoBack() =>
      const Action(InteractiveEnrollmentAction.clickGoBack);

  static Action settingParameters() =>
      const Action(InteractiveEnrollmentAction.settingParameters);

  static Action editAppInfo() =>
      const Action(InteractiveEnrollmentAction.editAppInfo);

  static Action onEditAppInfo(newValue) =>
      Action(InteractiveEnrollmentAction.onEditAppInfo, payload: newValue);

  static Action changeIdentity(newValue) =>
      Action(InteractiveEnrollmentAction.changeIdentity, payload: newValue);

  static Action onChangeIdentity(newValue) =>
      Action(InteractiveEnrollmentAction.onChangeIdentity, payload: newValue);

  static Action changeAppInfoState(newValue) =>
      Action(InteractiveEnrollmentAction.changeAppInfoState, payload: newValue);

  static Action onChangeAppInfoState(newValue) =>
      Action(InteractiveEnrollmentAction.onChangeAppInfoState,
          payload: newValue);

  static Action changeUserId(newValue) =>
      Action(InteractiveEnrollmentAction.changeUserId, payload: newValue);

  static Action onChangeUserId(newValue) =>
      Action(InteractiveEnrollmentAction.onChangeUserId, payload: newValue);

  static Action changeRoomId(newValue) =>
      Action(InteractiveEnrollmentAction.changeRoomId, payload: newValue);

  static Action onChangeRoomId(newValue) =>
      Action(InteractiveEnrollmentAction.onChangeRoomId, payload: newValue);
}
