import 'package:fish_redux/fish_redux.dart';
import 'package:flutter_livepush_demo/page/interactive/interactive_info/interactive_info_action.dart';
import 'interactive_info_state.dart';

Reducer<InteractiveInfoState> buildReducer() {
  return asReducer(
    <Object, Reducer<InteractiveInfoState>>{
      InteractiveInfoAction.onChangeAppId: _onChangeAppId,
      InteractiveInfoAction.onChangeAppKey: _onChangeAppKey,
      InteractiveInfoAction.onChangePlayDomain: _onChangePlayDomain,
    },
  );
}

InteractiveInfoState _onChangeAppId(InteractiveInfoState state, Action action) {
  final InteractiveInfoState newState = state.clone();
  newState.appId = action.payload ?? "";
  return newState;
}

InteractiveInfoState _onChangeAppKey(
    InteractiveInfoState state, Action action) {
  final InteractiveInfoState newState = state.clone();
  newState.appKey = action.payload ?? "";
  return newState;
}

InteractiveInfoState _onChangePlayDomain(
    InteractiveInfoState state, Action action) {
  final InteractiveInfoState newState = state.clone();
  newState.playDomain = action.payload ?? "";
  return newState;
}
