import 'package:fish_redux/fish_redux.dart';
import 'package:flutter_livepush_demo/common/CommonUtils.dart';
import 'interactive_mode_state.dart';

enum InteractiveModeAction {
  pageDidAppear,
  startPreview,
  clickBtnLink,
  updatePushStatus,
  updatePullStatus,
  updateCustomerInfo,
  updateCDNPlayerViewId,
  startLink,
  stopLink,
  clickSwitchCamera,
  clickMute,
  onClickMute,
  clickSwitchSpeaker,
  clickNext,
  goBackPage,
}

class InteractiveModeActionCreator {
  static Action pageDidAppear(appear) =>
      Action(InteractiveModeAction.pageDidAppear, payload: appear);
  static Action startPreview() =>
      const Action(InteractiveModeAction.startPreview);
  static Action clickBtnLink(isLink) =>
      Action(InteractiveModeAction.clickBtnLink, payload: isLink);
  static Action updatePushStatus(InteractivePushStatus pushStatus) =>
      Action(InteractiveModeAction.updatePushStatus, payload: pushStatus);
  static Action updatePullStatus(InteractivePullStatus pullStatus) =>
      Action(InteractiveModeAction.updatePullStatus, payload: pullStatus);
  static Action updateCustomerInfo(InteractiveCustomerInfo customerInfo) =>
      Action(InteractiveModeAction.updateCustomerInfo, payload: customerInfo);
  static Action updateCDNPlayerViewId(int viewId) =>
      Action(InteractiveModeAction.updateCDNPlayerViewId, payload: viewId);
  static Action startLink() => const Action(InteractiveModeAction.startLink);
  static Action stopLink() => const Action(InteractiveModeAction.stopLink);
  static Action clickSwitchCamera() =>
      const Action(InteractiveModeAction.clickSwitchCamera);
  static Action clickMute(bool mute) =>
      Action(InteractiveModeAction.clickMute, payload: mute);
  static Action onClickMute(bool mute) =>
      Action(InteractiveModeAction.onClickMute, payload: mute);
  static Action clickSwitchSpeaker() =>
      const Action(InteractiveModeAction.clickSwitchSpeaker);
  static Action clickNext() => const Action(InteractiveModeAction.clickNext);
  static Action goBackPage() => const Action(InteractiveModeAction.goBackPage);
}
