import 'package:fish_redux/fish_redux.dart';
import 'package:flutter_livepush_demo/common/CommonUtils.dart';
import 'package:flutter_livepush_demo/page/interactive/interactive_mode/interactive_mode_state.dart';

import 'interactive_mode_action.dart';

Reducer<InteractiveModeState> buildReducer() {
  return asReducer(
    <Object, Reducer<InteractiveModeState>>{
      InteractiveModeAction.pageDidAppear: _pageDidAppear,
      InteractiveModeAction.clickBtnLink: _clickBtnLink,
      InteractiveModeAction.onClickMute: _onClickMute,
      InteractiveModeAction.updatePushStatus: _updatePushStatus,
      InteractiveModeAction.updatePullStatus: _updatePullStatus,
      InteractiveModeAction.updateCustomerInfo: _updateCustomerInfo,
      InteractiveModeAction.updateCDNPlayerViewId: _updateCDNPlayerViewId,
      InteractiveModeAction.clickMute: _setMute,
    },
  );
}

InteractiveModeState _pageDidAppear(InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.pageDidAppear = action.payload;
  return newState;
}

InteractiveModeState _onClickMute(InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.mute = action.payload ?? false;
  return newState;
}

InteractiveModeState _clickBtnLink(InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.isClickLink = action.payload;
  return newState;
}

InteractiveModeState _updatePushStatus(
    InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.pushStatus = action.payload;
  return newState;
}

InteractiveModeState _updatePullStatus(
    InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.pullStatus = action.payload;
  return newState;
}

InteractiveModeState _updateCustomerInfo(
    InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.customerInfo = action.payload;
  return newState;
}

InteractiveModeState _updateCDNPlayerViewId(
    InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.cdnPlayerViewId = action.payload;
  return newState;
}

InteractiveModeState _setMute(InteractiveModeState state, Action action) {
  final InteractiveModeState newState = state.clone();
  newState.mute = action.payload;
  return newState;
}
