import 'package:fish_redux/fish_redux.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter_livepush_demo/common/CommonUtils.dart';
import 'package:flutter_livepush_plugin/live_push_config.dart';

enum InteractivePushStatus {
  none,
  pushing,
  pause,
  error,
  stop,
}

enum InteractivePullStatus {
  none,
  pulling,
  pause,
  error,
  stop,
}

class InteractiveCustomerInfo {
  String userId = "";
  String roomId = "";

  static InteractiveCustomerInfo create({String? userId, String? roomId}) {
    InteractiveCustomerInfo info = InteractiveCustomerInfo();
    info.userId = userId ?? "";
    info.roomId = roomId ?? "";
    return info;
  }
}

class InteractiveModeState implements Cloneable<InteractiveModeState> {
  InteractiveTypeEnum typeEnum = InteractiveTypeEnum.interactiveLive;
  InteractiveIdentityTypeEnum identityTypeEnum =
      InteractiveIdentityTypeEnum.anchor;
  String appId = "";
  String appKey = "";
  String playDomain = "";
  String userId = "";
  String roomId = "";
  bool pageDidAppear = false;
  AlivcLivePusherConfig pusherConfig = AlivcLivePusherConfig.init();
  bool isClickLink = false;
  InteractivePushStatus pushStatus = InteractivePushStatus.none;
  InteractivePullStatus pullStatus = InteractivePullStatus.none;
  InteractiveCustomerInfo customerInfo = InteractiveCustomerInfo.create();
  int cdnPlayerViewId = 0;
  bool mute = false;

  @override
  InteractiveModeState clone() => InteractiveModeState()
    ..typeEnum = typeEnum
    ..identityTypeEnum = identityTypeEnum
    ..appId = appId
    ..appKey = appKey
    ..playDomain = playDomain
    ..roomId = roomId
    ..userId = userId
    ..pageDidAppear = pageDidAppear
    ..isClickLink = isClickLink
    ..pushStatus = pushStatus
    ..pullStatus = pullStatus
    ..customerInfo = customerInfo
    ..cdnPlayerViewId = cdnPlayerViewId
    ..mute = mute;
}

InteractiveModeState initState(Map<String, dynamic> args) {
  return InteractiveModeState()
    ..typeEnum = args[interactiveTypeKey]
    ..identityTypeEnum = args[interactiveIdentityKey]
    ..appId = args[interactiveAppIdKey]
    ..appKey = args[interactiveAppKeyKey]
    ..playDomain = args[interactivePlayDomainKey]
    ..userId = args[interactiveUserIdKey]
    ..roomId = args[interactiveRoomIdKey]
    ..pusherConfig = args[pushConfigKey];
}
